#pragma once

#include "memory.h"
#include "pipe_opener_interface.h"
#include "pipe_paging.h"
#include "resource.h"

/* Support for providing access to pipes. */

class PipeOpenerResource : public Resource, public PipeOpener
{
protected:
    Memory *_memory;

    long open_endpoint(PipePaging *paging, bool writing, l4_cap_idx_t *endpoint);

public:
    explicit PipeOpenerResource(Memory *memory);

    explicit PipeOpenerResource();

    /* Server details. */

    int expected_items();

    ipc_server_handler_type handler();

    void *interface()
    { return static_cast<PipeOpener *>(this); }

    /* PipeOpener interface methods. */

    long pipe(offset_t size, l4_cap_idx_t *reader, l4_cap_idx_t *writer);
};

// vim: tabstop=4 expandtab shiftwidth=4
